<template>
  <button type="button" class="btn btn-primary" @click="onClick" :disabled="disabled">
    <span v-if="busy">
      <span class="spinner-border spinner-border-sm" role="status" aria-hidden="true"></span>
      {{ busyButtonText }}
    </span>
    <span v-else>
      <i aria-hidden="true" :class="buttonIconClass"></i>
      {{ buttonText }}
    </span>
  </button>
</template>

<script>
// Note: This is part of the identity module (not the core module) because it requires the user to be authenticated - a
// concept that the core module is unaware of. See the dependency on `useAuth` ?
import { ref, computed } from 'vue'
import { useApi } from '../../core'
import { useAuth } from '../plugins/auth-plugin.js'

export default {
  name: 'ActionButton',
  emits: ['click', 'success', 'failure'],
  props: {
    buttonText: { type: String, required: true },
    busyButtonText: { type: String, required: true },
    buttonIconClass: { type: String, required: true },
    resource: { type: String, required: true },
    request: { type: Object, default: null },
    isAuthenticated: { type: Boolean, default: true },
  },
  setup(props, context) {
    const api = useApi()
    const auth = useAuth()

    const busy = ref(false)
    const previousRequest = ref(undefined)

    const disabled = computed(() => {
      return busy.value
    })

    const onClick = () => {
      busy.value = true
      const options = props.isAuthenticated
        ? {
            headers: auth.getAuthHeaders(),

            // Get a handle on the request, so that we can cancel it.
            before(request) {
              previousRequest.value = request
            },
          }
        : {}

      api.http.post(props.resource, props.request, options).then(
        (response) => {
          busy.value = false
          context.emit('success', response)
        },
        (response) => {
          busy.value = false
          context.emit('failure', response)
        }
      )

      context.emit('click', previousRequest.value)
    }

    return {
      busy,
      previousRequest,
      disabled,
      onClick,
    }
  },
}
</script>
